#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include <SDL/SDL_image.h>

/* fetch SDL from libsdl.org */

/* screen width, height, and bit depth */
int SCREEN_WIDTH;
int SCREEN_HEIGHT;
int SCREEN_BPP;

/* Set up some booleans */
#define TRUE  1
#define FALSE 0

SDL_Surface *display;
SDL_Surface *background;
SDL_Surface *cursor;
SDL_Surface *mark;

SDL_Rect destination;
SDL_Rect olddestination;

int markstate=0;
int mouse_x, mouse_y;

void checkboundrys() 
{
	if ( destination.x + cursor->w > SCREEN_WIDTH ) { destination.x = SCREEN_WIDTH - cursor->w; }
	if ( destination.y + cursor->h > SCREEN_HEIGHT ) { destination.y = SCREEN_HEIGHT - cursor->h ; }
	if ( destination.x < 0 ) { destination.x = 0; }
	if ( destination.y < 0 ) { destination.y = 0; }
}

void drawcursor() 
{
				
				
	if ( markstate==1 ) 
	{
		destination.x = mouse_x - 2;
		destination.y = mouse_y - 2;
		checkboundrys();
		SDL_BlitSurface(mark, NULL, background, &destination);
	}

	destination.x = mouse_x;
	destination.y = mouse_y;
	checkboundrys();
	SDL_BlitSurface(background, NULL, display, NULL );
	SDL_BlitSurface(cursor, NULL, display, &destination);

	SDL_UpdateRect(display, destination.x , destination.y , cursor->w, cursor->h );
	SDL_UpdateRect(display, olddestination.x , olddestination.y , cursor->w , cursor->h  );
	olddestination = destination;

	if ( markstate==1 ) 
	{
		destination.x = mouse_x - 2;
		destination.y = mouse_y - 2;
		checkboundrys();
		SDL_UpdateRect(display, destination.x , destination.y , mark->w, mark->h );
	}
}

int main(int argc, char **argv) {

	background = IMG_Load( "background.png");
	cursor = IMG_Load( "cursor.png");
	mark = IMG_Load( "mark.png");

	SCREEN_WIDTH = 640;
    	SCREEN_HEIGHT = 480;
	SCREEN_BPP = 16;
	
	SDL_Init( SDL_INIT_VIDEO );

	atexit(SDL_Quit);

	display = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_HWSURFACE);

	SDL_ShowCursor(0);
	
	drawcursor();
	SDL_Flip(display);

	int done=0;
	
	SDL_Event event;
	
	while( done==0 ) 
	{
	        SDL_Delay(10); 
        	while ( SDL_PollEvent(&event) ) {


			if ( event.type == SDL_QUIT ) { done = 1; }
			if ( event.type == SDL_KEYDOWN ) 
			{ 
               			if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; } ;
               			if ( event.key.keysym.sym == SDLK_F1 ) { SDL_WM_ToggleFullScreen( display ); } ;
	               	}
	               	
			if ( event.type == SDL_MOUSEBUTTONDOWN )
			{
				markstate=1;
				drawcursor();
			}

			if ( event.type == SDL_MOUSEBUTTONUP )
			{
				markstate=0;
				drawcursor();
				                                
			}

               		if ( event.type == SDL_MOUSEMOTION ) 
               		{
				mouse_x = event.motion.x - cursor->w / 2;
				mouse_y = event.motion.y - cursor->h / 2;
				drawcursor();
	               	}
			
               		if (  event.type == SDL_ACTIVEEVENT ) 
               		{
				SDL_BlitSurface(background, NULL, display, NULL );
				SDL_BlitSurface(cursor, NULL, display, &destination);
				SDL_Flip(display);
			}
			                        
        	}
        }

	return 0;
}

